function y = FitNaturalSpline(S,x,gam,g)

% Fit a natural cubic spline to a vect of x-coordinates

% S = x-coordinates to fit spline
% x = original x-coordinates
% g = g-vector
% gam = gamma vector

% Inputs
n = length(x);

% Fit the spline (Green and Silverman, 1994, Equation (2.22)
for s=1:length(S)
    for i=1:n-1
        h(i) = x(i+1) - x(i);
        if (x(i) <= S(s)) && (S(s) <= x(i+1))
               y(s) = ((S(s)-x(i))*g(i+1) + (x(i+1)-S(s))*g(i))/h(i) ...
                    - 1/6*(S(s)-x(i))*(x(i+1)-S(s)) ...
                    * ( (1+(S(s)-x(i))/h(i))*gam(i+1) + (1+(x(i+1)-S(s))/h(i))*gam(i)) ;
        end
    end
end
